// -*- C++ -*-
// $Id$

// DYMO Printer Drivers
// Copyright (C) 2016 Sanford L.P.

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 31 Milk Street, # 960789, Boston, MA 02196 USA.

#include "PrinterDriver.h"

namespace DymoPrinterDriver
{

class CCupsPrintEnvironmentForDriver: public IPrintEnvironment
{
public:
    CCupsPrintEnvironmentForDriver(ILanguageMonitor& LanguageMonitor);
    virtual ~CCupsPrintEnvironmentForDriver();
    virtual bool WriteData(const buffer_t& DataBuffer);
    virtual bool ReadData(buffer_t& DataBuffer);
    virtual job_status_t GetJobStatus() { return jsOK; }
    virtual void SetJobStatus(job_status_t JobStatus) {}

private:
    FILE* PRNFile_;
    ILanguageMonitor& LanguageMonitor_;
};

class CCupsPrintEnvironmentForLM: public IPrintEnvironment
{
public:
    CCupsPrintEnvironmentForLM();
    virtual ~CCupsPrintEnvironmentForLM();
    virtual bool WriteData(const buffer_t& DataBuffer);
    virtual bool ReadData(buffer_t& DataBuffer);
    virtual job_status_t GetJobStatus();
    virtual void SetJobStatus(job_status_t JobStatus);

private:    
    IPrintEnvironment::job_status_t JobStatus_;
    bool isBluetooth_;
    bool isBonjour_;
    double timeout_;
};

};
